//js: Quiz: Random (x) Question from Array (x) question

/*----------CONFIG HERE----------*/
var numberQuestionToShow = quiz.length,
    txtResult = "Dein Ergebnis ist: ";
/*----------END CONFIG----------*/

var allQuestion = quiz.length,
    currentquestion = 0,
    score = 0,
    submt = true,
    ans = [],
    picked,
    arrChooseQuestion = [],
    countQuestion = 1;

jQuery(document).ready(function($) {


    //add title
    if (typeof quiztitle !== "undefined" && $.type(quiztitle) === "string") {
        $(document.createElement('h1')).text(quiztitle).appendTo('#title');
    } else {
        $(document.createElement('h1')).text("Quiz").appendTo('#title');
    }

    function htmlEncode(value) {
        return $(document.createElement('div')).text(value).html();
    }

    function addChoices(choices) {
        if (typeof choices !== "undefined" && $.type(choices) == "array") {
            $('#choice-block').empty();
            for (var i = 0; i < choices.length; i++) {
                $(document.createElement('li')).addClass('choice choice-box').attr('data-index', i).text(choices[i]).appendTo('#choice-block');
            }
        }
    }

    function addAnsChoices(choices, id, j) {
        if (typeof choices !== "undefined" && $.type(choices) == "array") {
            $('#choice-block').empty();
            for (var i = 0; i < choices.length; i++) {
                $(document.createElement('li')).addClass('choice choice-box choice'+j.toString()).attr('data-index', i).text(choices[i]).appendTo(id);
            }
        }
    }
    function addAnsChoicesResult(choices, id, j) {
        if (typeof choices !== "undefined" && $.type(choices) == "array") {
            $('#result-choice-block').empty();
            for (var i = 0; i < choices.length; i++) {
                $(document.createElement('li')).addClass('result-choice-box choice'+j.toString()).attr('data-index', i).text(choices[i]).appendTo(id);
            }
        }
    }

    function nextQuestion() {
        $('.choice').css({'display':'none'});
        $('#frame').css({'margin-bottom' : '0px'});
        $('#footer').css({'display' : 'none'});
        submt = true;
        $('#question').text(countQuestion+ ". " + quiz[currentquestion]['question']);
        $('#pager').text(countQuestion + ' / ' + numberQuestionToShow);
        /*
        if (quiz[currentquestion].hasOwnProperty('image') && quiz[currentquestion]['image'] != "") {
            if ($('#question-image').length == 0) {
                $(document.createElement('img')).addClass('question-image').attr('id', 'question-image').attr('src', quiz[currentquestion]['image']).attr('alt', htmlEncode(quiz[currentquestion]['question'])).insertAfter('#img');
            } else {
                $('#question-image').attr('src', quiz[currentquestion]['image']).attr('alt', htmlEncode(quiz[currentquestion]['question']));
            }
        } else {
            $('#question-image').remove();
        }
        */
        addChoices(quiz[currentquestion]['choices']);
        setupButtons();
    }

    function setupButtons() {
        $('#frame').css({'margin-bottom' : '70px'});
        $('.choice').on('click', function() {
            picked = $(this).attr('data-index');
            $('.choice').removeAttr('style').off('mouseout mouseover');
            $(this).css({
                'background-color': '#4aad33'
            });
            if (submt) {
                $('#footer').css({'display' : 'block'});
                submt = false;
                ans.push(picked);
                processQuestion(picked);
            }
        })
    }

    function processQuestion(choice) {

        if(countQuestion != numberQuestionToShow){
            //Check for duplication: currentquestion in arrChooseQuestion[]
            do{
                //Choose random Question -> Add to Array arrChooseQuestion[]
                currentquestion = Math.floor((Math.random() * quiz.length) + 0);
                //alert(currentquestion);
            }while(arrChooseQuestion.indexOf(currentquestion) >= 0);

            arrChooseQuestion.push(currentquestion);
        }
        countQuestion++;
        //$('#submitbutton').css({'display' : 'block'});
        
         $('#submitbutton').on('click', function () {
            if ((countQuestion-1) == numberQuestionToShow) {
                endQuiz();
            } else {
                $(this).text('').off('click');
                nextQuestion();
            }
         })
         
     }

    function endQuiz() {
        $('#footer').css({'display' : 'none'});
        $('#frame').css({'margin-bottom' : '120px'});
        
        // view all question without image and answer
        $('#frame').empty();
        $('#pager').empty();
        for (var i = 0; i < quiz.length; i++) {
            // add a div to contain question i
            var id = 'end-answer' + i.toString();
            $(document.createElement('div')).addClass('end-answer').attr('id', id).appendTo('#frame');

            //add question
            $(document.createElement('h2')).addClass('result-question').attr('id', 'question').text((i+1) + '.  '+ quiz[arrChooseQuestion[i]]['question']).appendTo('#' + id);

            //questions holder
            $(document.createElement('ul')).attr('id', 'result-choice-block'+i.toString()).appendTo('#' + id);

            //add choices
            addAnsChoicesResult(quiz[arrChooseQuestion[i]]['choices'], '#result-choice-block'+i.toString(), i);

            if (ans[i] == quiz[arrChooseQuestion[i]]['correct']) {
                $('.choice'+i.toString()).eq(ans[i]).addClass('result-choice-true');
                
                //$('#explanation'+i.toString()).html('<image class="iconResult" src="images/true.png"/> <strong style="color: #019214">Correct!</strong> ' + htmlEncode(quiz[i]['explanation']));
                //$('#explanation'+i.toString()).html('<image class="iconResult" src="images/true.png"/>' + htmlEncode(quiz[i]['explanation']));
                score++;
            } else {
                $('.choice'+i.toString()).eq(quiz[arrChooseQuestion[i]]['correct']).addClass('result-choice-true');
                $('.choice'+i.toString()).eq(ans[i]).addClass('result-choice-false');
                //$('#explanation'+i.toString()).html('<image class="iconResult" src="images/false.png"/> <strong style="color: #ff4b4b">Incorrect.</strong> ' + htmlEncode(quiz[i]['explanation']));
                //$('#explanation'+i.toString()).html('<image class="iconResult" src="images/false.png"/> ' + htmlEncode(quiz[i]['explanation']));
            }
            //$(document.createElement('hr')).addClass('hr').appendTo('#frame');
        }

        //Show Result
        $(document.createElement('div')).attr('id','result-content').appendTo('#title');
        $('#title>h1').css({'padding-left' : '0%'});
        $(document.createElement('p')).attr('id', 'result-score').html(txtResult + '&nbsp<span>' + score + ' / ' + numberQuestionToShow + '</span>').appendTo('#result-content');
        //$(document.createElement('p')).attr('id', 'result-2').html(Math.round(score / quiz.length * 100) + '%').appendTo('#result-content');
        
        //show Button
        $(document.createElement('div')).addClass('btn-action').attr('id','btn-reload').attr('onclick', 'window.location.reload(true);').appendTo('#result-content');
        $(document.createElement('div')).addClass('btn-action').attr('id','btn-back').attr('onclick', 'window.history.back();').appendTo('#result-content');


    }

    function init() {
        //Reset data
        ans = [];
        allQuestion = quiz.length;
        arrChooseQuestion = [];
        countQuestion = 1;
        currentquestion = 0;
        score = 0;

        //add pager and questions
        if (typeof quiz !== "undefined" && $.type(quiz) === "array") {
            //currentquestion = Choose random Question -> Add to Array arrChooseQuestion[]
            currentquestion = Math.floor((Math.random() * quiz.length) + 0);
            arrChooseQuestion.push(currentquestion);
            //alert(currentquestion);

            //add pager
            $(document.createElement('div')).attr('id', 'count-question').appendTo('#frame');
            $(document.createElement('span')).addClass('pager').attr('id', 'pager').text('1 / ' + numberQuestionToShow).appendTo('#title');
            //add first question
            $(document.createElement('h2')).addClass('question').attr('id', 'question').text(countQuestion+ ". " + quiz[currentquestion]['question']).appendTo('#frame');
            /*
            //add image if present
            $(document.createElement('div')).addClass('img').appendTo('#frame');
            if (quiz[0].hasOwnProperty('image') && quiz[0]['image'] != "") {
                $(document.createElement('img')).addClass('question-image').attr('id', 'question-image').attr('src', quiz[0]['image']).attr('alt', htmlEncode(quiz[0]['question'])).appendTo('#frame');
            }
            //$(document.createElement('p')).addClass('explanation').attr('id', 'explanation').html('&nbsp;').appendTo('#frame');
            */

            //questions holder
            $(document.createElement('ul')).attr('id', 'choice-block').appendTo('#frame');

            //add choices
            addChoices(quiz[currentquestion]['choices']);

            $(document.createElement('div')).attr('id', 'footer').appendTo('#frame-view');
            //add submit button
            $(document.createElement('div')).attr('id', 'submitbutton').text('').appendTo('#footer');
            //$('#submitbutton').css({'display' : 'none'});
            //$(document.createElement('div')).addClass('section').attr('id', 'section').html('&nbsp;').appendTo('#footer');
            $('#footer').css({'display' : 'none'});
            setupButtons();
        }
    }

    init();
});
